import talib
def indicator(df):
    df['ma5'] = talib.MA(df['close'], timeperiod=5)
    df['ma10'] = talib.MA(df['close'], timeperiod=10)
    df['ma20'] = talib.MA(df['close'], timeperiod=20)
    df['macd'], df['macdsignal'], df['macdhist'] = talib.MACD(df['close'], fastperiod=12, slowperiod=26, signalperiod=9)
    df['rsi'] = talib.RSI(df['close'], timeperiod=14)
    df['cci'] = talib.CCI(df['high'], df['low'], df['close'], timeperiod=14)
    df['dx'] = talib.DX(df['high'], df['low'], df['close'], timeperiod=14)
    df['slowk'], df['slowd'] = talib.STOCH(df['high'], df['low'], df['close'], fastk_period=9, slowk_period=3, slowk_matype=0, slowd_period=3, slowd_matype=0)
    df['fastk'], df['fastd'] = talib.STOCHF(df['high'], df['low'], df['close'], fastk_period=9, fastd_period=3, fastd_matype=0)
    df['willr'] = talib.WILLR(df['high'], df['low'], df['close'], timeperiod=14)
    df['mom'] = talib.MOM(df['close'], timeperiod=10)
    df['roc'] = talib.ROC(df['close'], timeperiod=10)
    df['trix'] = talib.TRIX(df['close'], timeperiod=30)
    df['aroonup'], df['aroondown'] = talib.AROON(df['high'], df['low'], timeperiod=14)
    df['aroonosc'] = talib.AROONOSC(df['high'], df['low'], timeperiod=14)
    df['bop'] = talib.BOP(df['open'], df['high'], df['low'], df['close'])
    df['midpoint'] = talib.MIDPOINT(df['close'], timeperiod=14)
    df['midprice'] = talib.MIDPRICE(df['high'], df['low'], timeperiod=14)
    df['sar'] = talib.SAR(df['high'], df['low'], acceleration=0, maximum=0)
    df['trange'] = talib.TRANGE(df['high'], df['low'], df['close'])
    df['atr'] = talib.ATR(df['high'], df['low'], df['close'], timeperiod=14)
    df['natr'] = talib.NATR(df['high'], df['low'], df['close'], timeperiod=14)
    df['adx'] = talib.ADX(df['high'], df['low'], df['close'], timeperiod=14)
    df['adxr'] = talib.ADXR(df['high'], df['low'], df['close'], timeperiod=14)
    df['apo'] = talib.APO(df['close'], fastperiod=12, slowperiod=26, matype=0)
    df['ppo'] = talib.PPO(df['close'], fastperiod=12, slowperiod=26, matype=0)
    df['mfi'] = talib.MFI(df['high'], df['low'], df['close'], df['volume'], timeperiod=14)
    df['minus_di'] = talib.MINUS_DI(df['high'], df['low'], df['close'], timeperiod=14)
    df['minus_dm'] = talib.MINUS_DM(df['high'], df['low'], timeperiod=14)
    df['plus_di'] = talib.PLUS_DI(df['high'], df['low'], df['close'], timeperiod=14)
    df['plus_dm'] = talib.PLUS_DM(df['high'], df['low'], timeperiod=14)
    df['rocp'] = talib.ROCP(df['close'], timeperiod=10)
    df['rocr'] = talib.ROCR(df['close'], timeperiod=10)
    df['rocr100'] = talib.ROCR100(df['close'], timeperiod=10)
    df['ultosc'] = talib.ULTOSC(df['high'], df['low'], df['close'], timeperiod1=7, timeperiod2=14, timeperiod3=28)
    df['ema5'] = talib.EMA(df['close'], timeperiod=5)
    df['ema10'] = talib.EMA(df['close'], timeperiod=10)
    df['ema20'] = talib.EMA(df['close'], timeperiod=20)
    df['dema5'] = talib.DEMA(df['close'], timeperiod=5)
    df['dema10'] = talib.DEMA(df['close'], timeperiod=10)
    df['dema20'] = talib.DEMA(df['close'], timeperiod=20)
    df['tema5'] = talib.TEMA(df['close'], timeperiod=5)
    df['tema10'] = talib.TEMA(df['close'], timeperiod=10)
    df['tema20'] = talib.TEMA(df['close'], timeperiod=20)
    df['trima5'] = talib.TRIMA(df['close'], timeperiod=5)
    df['trima10'] = talib.TRIMA(df['close'], timeperiod=10)
    df['trima20'] = talib.TRIMA(df['close'], timeperiod=20)
    df['wma5'] = talib.WMA(df['close'], timeperiod=5)
    df['wma10'] = talib.WMA(df['close'], timeperiod=10)
    df['wma20'] = talib.WMA(df['close'], timeperiod=20)
    df['kama5'] = talib.KAMA(df['close'], timeperiod=5)
    df['kama10'] = talib.KAMA(df['close'], timeperiod=10)
    df['kama20'] = talib.KAMA(df['close'], timeperiod=20)
